#ifndef _bergenServer_h_
#define _bergenServer_h_

#include "bergenListener.h"
#include "OscOutboundPacketStream.h"

class bergenServer
		{
		public:
		 bergenServer(char *server=NULL,int port=0);
		 ~bergenServer(void);
		 void reset(void);
		 void processMessages(void);
		 void addSound(class bergenSound*);
		 class bergenSound* findHandle(int handle);
		 void removeSound(class bergenSound*);
		 void addPath(char *);
		 char* path(void);
		 void sendMessage(const osc::OutboundPacketStream&);
		 int receiveHandle(void);
		 inline class bergenListener* listener(void) { return listenerClient_; };
		 inline bool connected(void) { return (transmitSocket && receiveSocket); };
		private:
		 class bergenListener* listenerClient_;
		 void connect(void);
		 char *serverName_;
		 int serverPort_;
		 struct _sound * soundList_;
		 char * path_;
		 class UdpTransmitSocket* transmitSocket;
		 class UdpReceiveSocket* receiveSocket;
		};


extern char * bergenVersion;

#endif
