#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include "osc/OscOutboundPacketStream.h"
#include "bergenListener.h"
#include "bergenServer.h"

int bergenListener::NextHandle = 1;


// PhysicalListener Constructor sets the initial position to 0,0,0 sets the
// killed flag ,increases the handle counter and creates an appropiate
// Physical Listener on the remote server 
bergenListener::bergenListener(class bergenServer *server)
	{
	server_ = server;
	handle_ = NextHandle++;
	killed_= 0;
	positionX_ = 0.0;
	positionY_ = 0.0;
	positionZ_ = 0.0;
	if(server_)
		createRemote();
	}	


// The bergen Listener destructor
bergenListener::~bergenListener(void)
	{	
	}	


// Creates it's representation on the remote server side 
void bergenListener::createRemote(void)
	{
	if (server_)
		{
		char buffer[1024];
		osc::OutboundPacketStream p( buffer, 1024 );
		p << osc::BeginMessage( "server" ) << "listener" << osc::EndMessage;	
		server_->sendMessage( p );
		handle_ = server_->receiveHandle();
		}
	else
		handle_ = 0;
	}


// Sets the bergen Listeners killed_ flag to mark it for remove 
void bergenListener::kill(void)
	{
	killed_ = 1;
	}


// Checks and returs the killed_ flag
int bergenListener::removable(void)
	{
	return killed_;
	}


// Kills it's representation on the remote server side 
void bergenListener::killRemote(void)
	{
	if (server_)
		{
		char buffer[1024];
		osc::OutboundPacketStream p( buffer, 1024 );
		p << osc::BeginMessage( "listener" ) << handle_ << "kill" << osc::EndMessage;	
		server_->sendMessage( p );
		}
	}


// Sets the listener position to the new given position
void bergenListener::setPosition(float x, float y, float z)
	{
	if (server_)
		{
		char buffer[1024];
		osc::OutboundPacketStream p( buffer, 1024 );
		p << osc::BeginMessage( "listener" ) << handle_ << "position" << x << y << z << osc::EndMessage;	
		server_->sendMessage( p );
		}
	positionX_ = x;
	positionY_ = y;
	positionZ_ = z;
	}
